#include <windows.h>

//The LOGFONT structure defines the attributes of a font
static LOGFONT logfont;
static HFONT   hFont;

BOOL WybierzCzcionke (HWND hwnd)
{
     CHOOSEFONT cf;
     
     cf.lStructSize    = sizeof (CHOOSEFONT) ;
     cf.hwndOwner      = hwnd;
     cf.hDC            = NULL;
     cf.lpLogFont      = &logfont;
     cf.iPointSize     = 0;
     cf.Flags          = CF_INITTOLOGFONTSTRUCT | CF_SCREENFONTS | CF_EFFECTS ;
     cf.rgbColors      = 0;
     cf.lCustData      = 0;
     cf.lpfnHook       = NULL;
     cf.lpTemplateName = NULL;
     cf.hInstance      = NULL;
     cf.lpszStyle      = NULL;
     cf.nFontType      = 0;      //zwracana z ChooseFont
     cf.nSizeMin       = 0;
     cf.nSizeMax       = 0;
     
	 //The ChooseFont function creates a Font dialog box that enables 
	 //the user to choose attributes for a logical font. These attributes include
	 //a typeface name, style (bold, italic, or regular), point size, 
	 //effects (underline, strikeout, and text color), and a script (or character set). 
     return ChooseFont (&cf) ;
}

void InicjalizujCzcionke (HWND hwndEdit)
{
     GetObject (GetStockObject (SYSTEM_FONT), sizeof (LOGFONT), 
                (PTSTR) &logfont);

	 //Initializes a CFont object with the characteristics given in a LOGFONT 
	 //structure pointed to by lpLogFont
     hFont = CreateFontIndirect (&logfont);
     SendMessage (hwndEdit, WM_SETFONT, (WPARAM) hFont, 0); 
}

void UstawCzcionke (HWND hwndEdit)
{
     HFONT hFontNew;
     RECT  rect;
     
     hFontNew = CreateFontIndirect (&logfont);
	 //ustawiam now czcionk
     SendMessage (hwndEdit, WM_SETFONT, (WPARAM) hFontNew, 0);
     DeleteObject (hFont);
     hFont = hFontNew;
	 //pobieram obszar klienta
     GetClientRect (hwndEdit, &rect);
	 //wymuszam odrysowanie zawartoci okienka
     InvalidateRect (hwndEdit, &rect, TRUE);
}

void UsunCzcionke (void)
{	 
	//usuwam stworzon czcionk
     DeleteObject (hFont);
}
