#include <windows.h>

BOOL bUserAbort;
HWND hDlgPrint;     

BOOL CALLBACK AbortProc (HDC hPrinterDC, int iCode)
{
     MSG msg;
     
     while (!bUserAbort && PeekMessage (&msg, NULL, 0, 0, PM_REMOVE))
     {
          if (!hDlgPrint || !IsDialogMessage (hDlgPrint, &msg))
          {
               TranslateMessage (&msg);
               DispatchMessage (&msg);
          }
     }
     return !bUserAbort;
}

BOOL DrukujRaport (HINSTANCE hInst, HWND hwnd, HWND hwndEdit, 
                       PTSTR szTitleName)
{
	//Typ danych DOCINFO zawiera nazwy plikw: wejciowego, i wyjciowego i jest 
	//tworzony na potrzeby funkcji StartDoc.
     static DOCINFO  di = {sizeof (DOCINFO)};

	 //Typ danych PRINTDIALOG (w oryginalnej definicji PRINTDLG) zawiera informacje
	 //wykorzystywane przez system do zainicjowania systemowych okien dialogowych 
	 //zwizanych z wydrukiem.
     static PRINTDLG pd;
     BOOL            bSuccess;
     int             yChar, iCharsPerLine, iLinesPerPage, iTotalLines,
                     iTotalPages, iPage, iLine, iLineNum;
     PTSTR           pstrBuffer;
     TCHAR           szJobName [64 + MAX_PATH];
     TEXTMETRIC      tm;
     WORD            iColCopy, iNoiColCopy;

     pd.lStructSize         = sizeof (PRINTDLG);
     pd.hwndOwner           = hwnd;
     pd.hDevMode            = NULL;
     pd.hDevNames           = NULL;
     pd.hDC                 = NULL;
     pd.Flags               = PD_ALLPAGES | PD_COLLATE | 
                              PD_RETURNDC | PD_NOSELECTION;
     pd.nFromPage           = 0;
     pd.nToPage             = 0;
     pd.nMinPage            = 0;
     pd.nMaxPage            = 0;
     pd.nCopies             = 1;
     pd.hInstance           = NULL;
     pd.lCustData           = 0L;
     pd.lpfnPrintHook       = NULL;
     pd.lpfnSetupHook       = NULL;
     pd.lpPrintTemplateName = NULL;
     pd.lpSetupTemplateName = NULL;
     pd.hPrintTemplate      = NULL;
     pd.hSetupTemplate      = NULL;
     
	 //Funkcja PrintDlg otwiera standardowe okno Windows suce do inicjowania 
	 //wydruku lub konfiguracji (setup) drukarki. Wszelkie dane definiujce to okno 
	 //musz by przekazane do zmiennej pPrintdlg (w oryginalnym opisie Microsoftu typ tej 
	 //zmiennej to PRINTDLG jednak ze wzgldu na zbieno nazw i fakt nie rozrniania
	 //przez VB maych i duych liter w nazwach przyjem tu nazw PRINTDIALOG - nazwa typu
	 //nie ma znaczenia). W przypadku poprawnego wykonania funkcja zwraca warto True 
	 //gdy funkcja zwraca False oznacza to bd, ktrego znaczenie moemy analizowa 
	 //korzystajc z funkcji CommDlgExtendedError. Zwrcone przez t funkcj dane mog 
	 //przyj wartoci (aby je bada naley je zapisa jako stae)

     if (!PrintDlg (&pd))
          return TRUE;
     
     if (0 == (iTotalLines = static_cast<int>(SendMessage (hwndEdit, EM_GETLINECOUNT, 0, 0))))
          return TRUE;

     // Calculate necessary metrics for file 
     
     GetTextMetrics (pd.hDC, &tm);
     yChar = tm.tmHeight + tm.tmExternalLeading;
     
     iCharsPerLine = GetDeviceCaps (pd.hDC, HORZRES) / tm.tmAveCharWidth;
     iLinesPerPage = GetDeviceCaps (pd.hDC, VERTRES) / yChar;
     iTotalPages   = (iTotalLines + iLinesPerPage - 1) / iLinesPerPage;

     // Allocate a buffer for each line of text
     
     pstrBuffer = static_cast<PSTR>(malloc (sizeof (TCHAR) * (iCharsPerLine + 1)));

     // Display the printing dialog box
     
     EnableWindow (hwnd, FALSE);
     
     bSuccess   = TRUE;
     bUserAbort = FALSE;

	 //Installs the abort procedure for the print job.
     SetAbortProc (pd.hDC, AbortProc);

     //Funkcja GetWindowText odczytuje tytu okna (czyli jego waciwo Caption). 
	 //Funkcja dziaa dla dowolnego okna a nie tylko stworzonego przez dan aplikacj.
	 //Odczytany tekst jest umieszczany w zmiennej acuchowej lpString. Funkcja zwraca 
	 //dugo odczytanego acucha a w przypadku bdu 0.
     GetWindowText (hwnd, szJobName, sizeof (szJobName));
     di.lpszDocName = szJobName;
     
	 //Funkcja StartDoc inicjuje zadanie wydruku zastpujc standardow procedur 
	 //inicjujc (STARTDOC printer escape). Gdy funkcja zostaa wykonana prawidowo 
	 //zwracana warto jest wiksza od zera, w przeciwnym przypadku wystpi bd, 
	 //ktry mona bada przy pomocy funkcji GetLastError.
     if (StartDoc (pd.hDC, &di) > 0)
     {
          // Collation requires this loop and iNoiColCopy
          for (iColCopy = 0;
               iColCopy < ((WORD) pd.Flags & PD_COLLATE ? pd.nCopies : 1);
               iColCopy++)
          {
               for (iPage = 0 ; iPage < iTotalPages ; iPage++)
               {
                    for (iNoiColCopy = 0;
                         iNoiColCopy < (pd.Flags & PD_COLLATE ? 1 : pd.nCopies);
                         iNoiColCopy++)
                    {
                         // Start the page
                         if (StartPage (pd.hDC) < 0)
                         {
                              bSuccess = FALSE;
                              break;
                         }

                         // For each page, print the lines   
                         for (iLine = 0 ; iLine < iLinesPerPage ; iLine++)
                         {
                              iLineNum = iLinesPerPage * iPage + iLine;
                              
                              if (iLineNum > iTotalLines)
                                   break;
                              
                              *(int *) pstrBuffer = iCharsPerLine;

							  //Za  pomoc TextOut moemy wywietli (wydrukowa) dowolny tekst. 
							  //Jeli wszystko jest w porzdku funkcja zwraca TRUE, a jeli
							  //co jest nie tak to zostanie zwrcone FALSE.
                              TextOut (pd.hDC, 0, yChar * iLine, pstrBuffer,
                                       (int) SendMessage (hwndEdit, EM_GETLINE,
                                       (WPARAM) iLineNum, (LPARAM) pstrBuffer));
                         }
                         
                         if (EndPage (pd.hDC) < 0)
                         {
                              bSuccess = FALSE;
                              break;
                         }
                         
                         if (bUserAbort)
                              break;
                    }
                    
                    if (!bSuccess || bUserAbort)
                         break;
               }
               
               if (!bSuccess || bUserAbort)
                    break;
          }
     }
     else
          bSuccess = FALSE;
     
     if (bSuccess)
          EndDoc (pd.hDC);
     
     if (!bUserAbort)
     {
          EnableWindow (hwnd, TRUE);
          DestroyWindow (hDlgPrint);
     }
     
     free (pstrBuffer);
	
	 //Funkcja DeleteDC usuwa wyspecyfikowany kontekst urzdzenia (device context - DC).
	 //Aplikacja, ktra wywoaa okrelony kontekst urzdzenia przez funkcj GetDC 
	 //powinna wczeniej zwolni zasoby wywoujc funkcj ReleaseDC. W przypadku powodzenia 
	 //funkcja zwraca True. Warto False oznacza bd
     DeleteDC (pd.hDC);
     
     return bSuccess && !bUserAbort ;
}