#include "Algorytm.h"
#include "Czcionka.h"
#include "Drukuj.h"
#include "resource.h"
#include "IOPlik.h"
#include <time.h>

//do dzwiku doda linkerowi winmm.lib
//biblioteki do czenia
#pragma comment( lib, "winmm.lib")

int Enter = 0;
int ENT = 1;
int FLAGA = 0;
int DRUKUJ = 0;
int BLAD = 0;

//pomocnicze flagi ustawiajce pola w menu na aktywne/nieaktywne
int mStart = 1;
int mWyczysc = 0;
int mLicz = 0;
int mZpliku = 0;
int mZapisz = 0;

//do okienka o programie
static HINSTANCE hDlgAbout;

//do okienka O nas
static HINSTANCE hDlgOnas;

//do okienka o Balasie
static HINSTANCE hDlgOBalasie;

//deklaracje zapowiadajce
void InicjalizujCzcionke (HWND);
BOOL WybierzCzcionke (HWND);
void UstawCzcionke (HWND);
void UsunCzcionke (void);

//funkcja wypisujca acuchy
void wypisz(HWND hwndEdit, char* szFormat, ...);

//prosta funkcja obslugi bldw
int Blendy (HWND hwnd, char *);

//funkcja wczytujca parametry z pliku
void Wczytaj_Z_Pliku(HWND hwnd, PARAMETRY *pdp);

//funkcja zapisujca raport do pliku
void Zapisz_Do_Pliku(HWND hwnd, PARAMETRY *pdp);

//funkcja pytajca czy na pewno zakoczy program
void Pytanie(HWND okno);

//procedura zdarzeniowa
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

//pomocnicza procedura zdarzeniowa dla innych okienek
BOOL CALLBACK AboutDlgProc(HWND, UINT, WPARAM, LPARAM);

//funkcja informujca o rnych bdach i nie tylko
void Err_Komunikat(COLORREF kolor, HWND hwnd, char *tekst);

//Funkcja nadzorujca poprawne wprowadzanie danych z klawiatury
void  WczytajWszystko(HWND hwnd, char *tab, PARAMETRY *pdp);

//funkcja wypisujca raport na ekran
void Raport(HWND hwnd, PARAMETRY *pdp);

//funkcja WinMain()
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
     static TCHAR szAppName[] = TEXT ("Balas") ;
     HWND         hwnd ;
     MSG          msg ;
     WNDCLASS     wndclass ;
	 HACCEL hAccelerator;

     wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
     wndclass.lpfnWndProc   = WndProc ;
     wndclass.cbClsExtra    = 0 ;
     wndclass.cbWndExtra    = 0 ;
     wndclass.hInstance     = hInstance ;
     wndclass.hIcon         = LoadIcon (hInstance, "IKONKA") ;
     wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
     wndclass.hbrBackground = (HBRUSH) GetStockObject (LTGRAY_BRUSH);
     wndclass.lpszMenuName  = "MENU";  
     wndclass.lpszClassName = szAppName ;
     
	 //rejestracja klasy okna
     if (!RegisterClass (&wndclass))
     {
          MessageBox (NULL, TEXT ("Bd inicjalizacji okna!"), 
                      szAppName, MB_ICONERROR) ;
          return 0 ;
     }
     
	 //tworzymy okienko
     hwnd = CreateWindow (szAppName, TEXT ("Algorytm Balas"),
                          WS_OVERLAPPED | WS_CLIPCHILDREN | WS_BORDER
						  | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,                   
						  220, // x
						  120, // y
						  620, // szeroko
						  640, // wysoko
                          NULL, NULL, hInstance, NULL) ;

	 //aby dziaay klawisze skrtw
	 hAccelerator = LoadAccelerators(hInstance, "ACCELERATOR");
	
	 //pokazujemy stworzone okienko
     ShowWindow (hwnd, iCmdShow) ;
     UpdateWindow (hwnd) ;

	 //ptla obsugi komunikatw zwana take pomp komunikatw :)
     while (GetMessage (&msg, NULL, 0, 0))    
	 {
		 //funkcja przetwarza wszystkie nacinite klawisze i sprawdza, 
		 //czy nie s klawiszami skrtw do ktrej z komend menu
		 if (!TranslateAccelerator(hwnd,hAccelerator,&msg))
		 {
			TranslateMessage (&msg);
			DispatchMessage (&msg);
		 }
     }
	 //zwracamy kod wyjcia
	 return static_cast<int>(msg.wParam);
}

//procedura zdarzeniowa
LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	 HINSTANCE hInstance2=0;
	 static HWND hwndEdit;
	 static PARAMETRY *pdp ;
	 HDC hdc;
	 PAINTSTRUCT ps;
	
	 //do drukowania
	 static TCHAR szTitleName[MAX_PATH] ;
	 static HINSTANCE hInst;

	 //ustawiam wskanik na zmienn typu PARAMETRY
	 pdp = &parametry;
  
     switch (message)
     {
	 case WM_CREATE:
		 {
		 hFont=CreateFont(15,0,0,0,0,0,0,0,0,0,0,0,0, "MS Sans Serif");
		 
		 //tworzymy wszystkie przyciski i okienka
		 hwndEdit = CreateWindowEx(WS_EX_CLIENTEDGE, "edit", NULL,
						WS_CHILD | WS_VISIBLE | WS_HSCROLL | 
						WS_VSCROLL | WS_BORDER | ES_LEFT |
						ES_MULTILINE | ES_NOHIDESEL | ES_AUTOHSCROLL | 
						ES_AUTOVSCROLL | ES_READONLY ,
						10,10,500,482, hwnd, (HMENU)1001, hInstance2, NULL);

		 CreateWindowEx(WS_EX_CLIENTEDGE,"edit", NULL, WS_CHILD | WS_VISIBLE | WS_HSCROLL | 
						 WS_BORDER | ES_LEFT |
						ES_MULTILINE | ES_NOHIDESEL |
						ES_AUTOVSCROLL , 10,500,500,42, hwnd, (HMENU)1002, hInstance2, NULL);

		 //okno w ktrym bdziemy informowa o bdach
		 CreateWindowEx(WS_EX_CLIENTEDGE, "static", NULL, 
						WS_CHILD | WS_VISIBLE | ES_READONLY,
						10, 550, 500, 22, hwnd, (HMENU)1003, hInstance2, NULL);
		 
		 CreateWindow("button", "START", WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON, 520,10,84,22, hwnd, (HMENU)2, hInstance2, NULL);
		 CreateWindow("button", "WYCZY", WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON, 520,35,84,22, hwnd, (HMENU)3, hInstance2, NULL);
		 CreateWindow("button", "LICZ", WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON, 520,135,84,22, hwnd, (HMENU)4, hInstance2, NULL);
		 CreateWindow("button", "Z PLIKU", WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON, 520,60,84,22, hwnd, (HMENU)5, hInstance2, NULL);
		 CreateWindow("button", "ZAPISZ", WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON, 520,85,84,22, hwnd, (HMENU)6, hInstance2, NULL);
		 CreateWindow("button", "NOTATNIK", WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON, 520,185,84,22, hwnd, (HMENU)7, hInstance2, NULL);
		 CreateWindow("button", "KALKULATOR", WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON, 520,210,84,22, hwnd, (HMENU)8, hInstance2, NULL);	

		 // ustawiam czcionk na przyciskach
		 SendMessage(GetDlgItem(hwnd, 1), WM_SETFONT, (WPARAM)hFont, TRUE);
		 SendMessage(GetDlgItem(hwnd, 2), WM_SETFONT, (WPARAM)hFont, TRUE);
		 SendMessage(GetDlgItem(hwnd, 3), WM_SETFONT, (WPARAM)hFont, TRUE);
		 SendMessage(GetDlgItem(hwnd, 4), WM_SETFONT, (WPARAM)hFont, TRUE);
		 SendMessage(GetDlgItem(hwnd, 5), WM_SETFONT, (WPARAM)hFont, TRUE);
		 SendMessage(GetDlgItem(hwnd, 6), WM_SETFONT, (WPARAM)hFont, TRUE);
		 SendMessage(GetDlgItem(hwnd, 7), WM_SETFONT, (WPARAM)hFont, TRUE);
		 SendMessage(GetDlgItem(hwnd, 8), WM_SETFONT, (WPARAM)hFont, TRUE);

		 //ustawiam czcionk do wypisywania
		 InicjalizujCzcionke(hwndEdit);

		 //bez tego nie ma alladyna :-)
		  hDlgAbout = ((LPCREATESTRUCT) lParam)->hInstance;
		  //i dzieciaka
		  hDlgOnas = ((LPCREATESTRUCT) lParam)->hInstance;
		  //zdjcie balasa
		  hDlgOBalasie = ((LPCREATESTRUCT) lParam)->hInstance;
		  //do drukowania
		  hInst = ((LPCREATESTRUCT) lParam) -> hInstance ;

		//ustawiam przycisk RAPORT na nieaktywny
		EnableWindow(GetDlgItem (hwnd, 4),FALSE); mLicz = 0;
		//ustawiamy przycisk Zapisz na nieaktywny
		EnableWindow(GetDlgItem (hwnd, 6),FALSE); mZapisz = 0;
		//przycisk WYCZYSC nieaktywny
		EnableWindow(GetDlgItem (hwnd, 3),FALSE); mWyczysc = 0;
		EnableWindow(GetDlgItem (hwnd, 5),FALSE); mZpliku = 0;

		 return 0;
		 }    
     case WM_PAINT:
		 //tutaj nastpuje odrysowanie okienka
		 hdc = BeginPaint (hwnd, &ps);

		 EndPaint (hwnd, &ps);
         return 0 ;

	case WM_COMMAND:
		switch(LOWORD(wParam))	
		{
			//przycisk ENTER
			case 1:
				if (ENT == 0)
				{
					Err_Komunikat(RGB(255, 255,0), hwnd, "Nacinij przycisk WYCZY");
					SetDlgItemText(hwnd, 1002, NULL);
				}

				else if (Enter == 1) 
				{
					char tab[100];

					GetDlgItemText(hwnd, 1002, tab, 100);
					WczytajWszystko(hwnd, tab, pdp);
					EnableWindow(GetDlgItem (hwnd, 5),FALSE); mZpliku = 0;
				}
				else 
				{
					Err_Komunikat(RGB(255, 255,0), hwnd, "Nacinij przycisk START.");
					SetDlgItemText(hwnd, 1002, NULL);
				} 
				break;

			   //przycisk START
			case ID_BALAS_START:
			case 2:
				if(mStart == 1)
				{
					FLAGA = 0;
					SetDlgItemText(hwnd, 1001, NULL);
					Err_Komunikat(RGB(255, 255,0), hwnd, "Program gotowy do pracy.");
					wypisz(hwnd, "%s\r\n","Zero jedynkowy addytywny algorytm Balasa");
					wypisz(hwnd, "%s\r\n","");
					wypisz(hwnd, "%s\r\n","Podaj liczb zmiennych decyzyjnych");
				
					SetFocus (GetDlgItem (hwnd, 1002));
					EnableWindow(GetDlgItem (hwnd, 2),FALSE); mStart = 0;
					EnableWindow(GetDlgItem (hwnd, 3),TRUE); mWyczysc = 1;
					//ustawiam przycisk RAPORT na nieaktywny
					EnableWindow(GetDlgItem (hwnd, 4),FALSE); mLicz = 0;
					//ustawiamy przycisk Zapisz na nieaktywny
					EnableWindow(GetDlgItem (hwnd, 6),FALSE); mZapisz = 0;
					EnableWindow(GetDlgItem (hwnd, 5),TRUE); mZpliku = 1;
					Enter = 1;
				}
				else
					MessageBox(hwnd, "Przycisk nie jest aktywny", "Informacja", MB_OK | MB_ICONINFORMATION);

				break;
			
				//przycisk WYCZYSC
			case ID_BALAS_WYCZY107:
			case 3:
				if(mWyczysc == 1)
				{
					DRUKUJ = 0;
					//zaczynamy cae wprowadzanie od nowa
					Err_Komunikat(RGB(255, 255,0), hwnd, "Zacznij wprowadzanie danych od pocztku.");
					SetDlgItemText(hwnd, 1001, NULL);
					FLAGA = 0;
					Enter = 0;
					ENT = 1;
					SetDlgItemText(hwnd, 1002, NULL);
				
					//ustawiam przycisk RAPORT na nieaktywny
					EnableWindow(GetDlgItem (hwnd, 4),FALSE); mLicz = 0;
					//ustawiamy przycisk Zapisz na nieaktywny
					EnableWindow(GetDlgItem (hwnd, 6),FALSE); mZapisz = 0;
					//przycisk START aktywny
					EnableWindow(GetDlgItem (hwnd, 2),TRUE); mStart = 1;
					//przycisk WYCZY nieaktywny
					EnableWindow(GetDlgItem (hwnd, 3),FALSE); mWyczysc = 0;
					EnableWindow(GetDlgItem (hwnd, 5),FALSE); mZpliku = 0;
		
					//Zeruje zmienne
					pdp->N = 0;
					pdp->M = 0;
				}
				else
					MessageBox(hwnd, "Przycisk nie jest aktywny", "Informacja", MB_OK | MB_ICONINFORMATION);

				break;
			
				//przycisk RAPORT
			case ID_BALAS_RAPORT:
			case 4:
				if(mLicz == 1)
				{
					Balas(pdp);
					Raport(hwnd, pdp);
				}
				else
				MessageBox(hwnd, "Przycisk nie jest aktywny", "Informacja", MB_OK | MB_ICONINFORMATION);
				break;
			
				//przycisk Z PLIKU i z menu Plik->Otwrz
			case ID_PLIK_OTW:
			case 5:
				if(mZpliku == 1)
				{
					EnableWindow(GetDlgItem (hwnd, 2),FALSE); mStart = 0;
					EnableWindow(GetDlgItem (hwnd, 3),TRUE); mWyczysc = 1;
					EnableWindow(GetDlgItem (hwnd, 5),FALSE); mZpliku = 0;
					Err_Komunikat(RGB(255, 255,0), hwnd, "Wczytywanie danych z pliku.");
					Wczytaj_Z_Pliku(hwnd, pdp);
				}
				else
					MessageBox(hwnd, "Przycisk nie jest aktywny", "Informacja", MB_OK | MB_ICONINFORMATION);
				break;

				//przycisk ZAPISZ
			case ID_PLIK_ZAPISZ:
			case 6:
				if(mZapisz == 1)
				{
					if(DRUKUJ == 0)
						MessageBox(hwnd, "Raport jeszcze nie jest gotowy", "Informacja", MB_OK | MB_ICONINFORMATION);
					else
					{
						Err_Komunikat(RGB(255, 255,0), hwnd, "Zapisywanie raportu do pliku.");
						Zapisz_Do_Pliku(hwnd, pdp);
					}
				}
				else MessageBox(hwnd, "Przycisk nie jest aktywny", "Informacja", MB_OK | MB_ICONINFORMATION);
			break;
			
			case 7:
				WinExec("notepad.exe", SW_SHOW);
				break;

			case 8:
				WinExec("calc.exe", SW_SHOW);
				break;

			//wydrukowanie dokumentu
			case ID_PLIK_DRUKUJ:
				if(DRUKUJ == 1)
				{
					Err_Komunikat(RGB(255, 255,0), hwnd, "Drukowanie raportu.");
					if(!(DrukujRaport (hInst, hwnd, hwndEdit, szTitleName)))
					MessageBox(hwnd, "Nie mona drukowa!!!", "Informacja", 
								MB_OK | MB_ICONINFORMATION);
				}
				else
					MessageBox(hwnd, "Raport jeszcze nie jest gotowy", "Informacja", MB_OK | MB_ICONINFORMATION);
				
				break;

			case ID_PLIK_ZAMKNIJ:
				Err_Komunikat(RGB(255, 255,0), hwnd, "Zamykanie programu.");
				Pytanie(hwnd);
            break;
			
			//wybieramy now czcionk
			case ID_CZCIONKA_NOWA:
				Err_Komunikat(RGB(255, 255,0), hwnd, "Ustawianie nowej czcionki.");
				if (WybierzCzcionke (hwnd))
                    UstawCzcionke (hwndEdit) ;
                break;
				
				//Help ->Algorytm Balasa - informacje
			case ID_HELP_ALGORYTMBALASA110:
				DialogBox (hDlgAbout, TEXT ("OPROGRAMIE"), hwnd, AboutDlgProc);
				break;

				//Help ->Balas - biografia
			case ID_HELP_BALAS:
				DialogBox (hDlgOBalasie, TEXT("OBALASIE"), hwnd, AboutDlgProc);
				break;

				//help ->O nas 
			case ID_HELP_ONAS:
				DialogBox (hDlgOnas, TEXT ("ONAS"), hwnd, AboutDlgProc);
				break;
		}
		
		return 0;

		case WM_CLOSE:
			Err_Komunikat(RGB(255, 255,0), hwnd, "Zamykanie programu.");
		    if(MessageBox(NULL, "Czy na pewno zakoczy program?","Zakoczenie", 
			   MB_YESNO | MB_ICONQUESTION) ==IDYES)
					DestroyWindow(hwnd);
		return 0;
        
     case WM_DESTROY:
		  //zwalniam przydzielon wczeniej pami dla tablic
		  free(pdp->tab_A);
		  free(pdp->tab_B);
		  free(pdp->tab_C);
		  free(pdp->tab_X);

		  UsunCzcionke();
          PostQuitMessage (0) ;
          return 0 ;

     }
	 //tutaj trafiaj wszystkie nie obsuone komunikaty
     return DefWindowProc (hwnd, message, wParam, lParam) ;
}


//pomocnicza procedura zdarzeniowa dla okienka "O programie" i "O nas"
BOOL CALLBACK AboutDlgProc (HWND hDlg, UINT message, 
                            WPARAM wParam, LPARAM lParam)
{
     switch (message)
     {
     case WM_INITDIALOG :
          return TRUE ;
		  
	 case WM_CLOSE:
		 EndDialog (hDlg, 0) ;
               return TRUE ;
          
     case WM_COMMAND :
          switch (LOWORD (wParam))
          {
          case IDOK:
               EndDialog (hDlg, 0) ;
               return TRUE ;
          }
          break ;
     }
     return FALSE ;
}

//funkcja wywoywana przy prbie zakoczenia programu
void Pytanie(HWND okno)
{
	if(MessageBox(okno, "Czy na pewno chcesz zakoczy program?", "Pytanie", 
				  MB_YESNO | MB_ICONQUESTION) ==IDYES)
				  DestroyWindow(okno);
}

//funkcja sprawdzajca poprawno wprowadzonych danych
int Blendy(HWND hwnd, char  *tab)
{
	int blad = 1;	 

	//jeli pierwszy znak jest minusem
	if (*(tab) == '-')
	{
		for(unsigned int i = 1; i < strlen(tab); i++)
		{
			if(*(tab + i) >= '0' && *(tab + i) <= '9') 
			{
         		blad = 0;
			}
			else
			{
				blad =1;
				break;
			}
		}
	}

	//jeli pierwszy znak jest cyfr
	if(*(tab) >= '0' && *(tab) <='9')
	{
		for(unsigned int i = 1; i < strlen(tab); i++)
		{
			if(*(tab + i) >= '0' && *(tab + i) <= '9') 
			{
         		blad = 0;
			}
			else
			{
				blad =1;
				break;
			}
		}
	}

	//jeli wprowadzono tylko jedn cyfr
	if(strlen(tab) == 1)
	{
		if(*(tab) >= '0' && *(tab) <= '9') 
		{
         	blad = 0;
		}
		else
		{
			blad =1;
		}
	}

	//jeli wykryto bd
    if(blad == 1) 
	{
		return 0;
	}

	//jeli nie ma bdw
    if (blad == 0)
	{
		return 1;
	}
	return 0;
}

//funkcja wczytujca dane z pliku
void Wczytaj_Z_Pliku(HWND hwnd, PARAMETRY *pdp)
{
	//Typ danych OPENFILENAME wykorzystuj zmienne okien dialogowych Windows: 
	//Otwrz plik GetOpenFileName i Zapisz plik GetSaveFileName. Zmienne s 
	//wykorzystywane do przekazania danych niezbdnych do zainicjowania okna 
	//a po jego zamkniciu zawieraj dane zwizane z dokonanym wyborem.
	OPENFILENAME ofn;
    char szFileName[MAX_PATH] = "balas.txt";
	
    ZeroMemory(&ofn, sizeof(ofn));
    ofn.lStructSize = sizeof(ofn); //dugo zmiennej w bajtach
    ofn.hwndOwner = hwnd; //uchwyt okna, z ktrego poziomu otwieramy dialogowe
	ofn.lpstrFilter = "Text Files (*.txt)\0*.txt\0";
    ofn.lpstrFile = szFileName; //nazwa pliku
    ofn.nMaxFile = MAX_PATH;
	//OFN_HIDEREADONLY ukrycie Open As Read Only check box (tylko w Otwrz plik)
    //OFN_FILEMUSTEXIST tylko spord istniejcych plikw
    ofn.Flags = OFN_EXPLORER |OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
    ofn.lpstrDefExt = "txt"; //domylne rozszerzenie 

	//Funkcja GetOpenFileName otwiera standardowe okno Windows suce do otwierania
	//plikw. Wszelkie dane definiujce to okno musz by przekazane do zmiennej 
	//pOpenfilename. Informacja o wybranych plikach (jeli wybrano) jest rwnie 
	//zapisywana w tej samej zmiennej. Funkcja zwraca 0 w przypadku bdu lub gdy 
	//uytkownik wybierze Cancel. W przypadku powodzenia zwraca warto niezerow.
    if(GetOpenFileName(&ofn))
    {
		//funkcja wczytujca dane z pliku
		if(!(Odczyt(&szFileName[0], pdp, hwnd)))
		{
			mLicz = 1;
			mZapisz = 1;
			ENT = 0;
			SetDlgItemText(hwnd, 1001, NULL);
			wypisz(hwnd, "%s\r\n", "Zero jedynkowy addytywny algorytm Balasa");
		}
    }
}

//funkcja zapisujca raport do pliku
void Zapisz_Do_Pliku(HWND hwnd, PARAMETRY *pdp)
{
	OPENFILENAME ofn;
    char szFileName[MAX_PATH] = "raport.txt";
	
    ZeroMemory(&ofn, sizeof(ofn));
    ofn.lStructSize = sizeof(ofn);
    ofn.hwndOwner = hwnd;
    ofn.lpstrFilter = "Text Files (*.txt)\0*.txt\0";
    ofn.lpstrFile = szFileName;
    ofn.nMaxFile = MAX_PATH;
	//OFN_OVERWRITEPROMPT komunikat w przypadku wybrania nazwy istniejcego pliku
    ofn.Flags = OFN_EXPLORER | OFN_OVERWRITEPROMPT;
    ofn.lpstrDefExt = "txt";

	//Funkcja GetSaveFileName otwiera standardowe okno dialogowe Windows 
	//suce do zapisu plikw. Wszystkie niezbdne informacje s przekazywane 
	//do funkcji za porednictwem zmiennej pOpenfilename. Rwnie wybrana nazwa pliku 
	//(jeli j wybrano) jest zapisywana w tej zmiennej. W przypadku bdu funkcja 
	//zwraca 0 inna warto oznacza powodzenie.
    if(GetSaveFileName(&ofn))
    {
		//funkcja zapisujca do pliku
		Zapis(&szFileName[0],pdp);
		wypisz(hwnd, "%s\r\n\r\n","");
		wypisz(hwnd, "%s\r\n","Zapisano raport w pliku ");
		wypisz(hwnd, "%s\r\n", szFileName); //wypisuje cala sciezke dostepowa do pliku
		Err_Komunikat(RGB(0, 0, 230), hwnd, "Raport zapisano pomylnie");;
		PlaySound (("Media\\tada.wav"), 
		NULL, SND_FILENAME | SND_ASYNC) ;
    }
}

//funkcja informujca o bdach
void Err_Komunikat(COLORREF kolor, HWND hwnd, char *tekst)
{
	HDC hdc;
	RECT r;
	
	//pobieram obszar klienta okna
	GetClientRect(GetDlgItem (hwnd, 1003), &r); 
	//pobieram kontekst urzdzenia
	hdc = GetDC(GetDlgItem (hwnd, 1003));
	
	//Kasuje poprzedni komunikat
	FillRect(hdc, &r, (HBRUSH) GetStockObject (LTGRAY_BRUSH));
	SetBkMode(hdc, TRANSPARENT); //ustawienie ta
	SetTextColor(hdc, kolor); //ustawienie koloru
	
	TextOut(hdc, 0, 0, tekst, static_cast<int>(strlen(tekst))); //wypisanie tekstu
	//zwalniam kontekst urzdzenia
	ReleaseDC(hwnd, hdc);
}

//funkcja wypisujca na ekran
void wypisz(HWND hwnd, char* szFormat, ...)
{
	HWND hwndEdit = GetDlgItem(hwnd, 1001);
	char szBuf[1024];
	va_list pArgList;

	va_start(pArgList, szFormat);
	vsprintf(szBuf, szFormat, pArgList);
	va_end(pArgList);

	SendMessage (hwndEdit, EM_SETSEL, (WPARAM) -1, (LPARAM) -1) ;
	SendMessage (hwndEdit, EM_REPLACESEL, FALSE, (LPARAM)szBuf) ;
	SendMessage (hwndEdit, EM_SCROLLCARET, 0, 0) ;
}

//funkcja wprowadzajca dane z klawiatury
void  WczytajWszystko(HWND hwnd, char *tab, PARAMETRY *pdp)
{
   unsigned int spacja = 0;
   int flaga = 0;
   int err = 1;
   char pomocnicza[100];
   int i = 0;
   int c = 0;
   int licznik = 0;
   
   strcat(tab," "); //dodaje spacj do wczytanego acucha
   ZeroMemory(&pomocnicza, sizeof(pomocnicza));
   
   for(unsigned int i=0; i<strlen(tab); i++)
   {
	   if(*(tab+i) == ' ')
       {
		    licznik++;	//licze ilo wprowadzonych liczb w stringu
		    for(spacja; spacja< i-flaga; spacja++)
		    {
         		pomocnicza[spacja] = *(tab + spacja + flaga);
			}
			spacja = 0;
			flaga = i+1;
		 
			if(Blendy(hwnd, pomocnicza))
			{
				if((FLAGA == 0) && (licznik == 1)) //wczytuje ilo zmiennych funkcji celu
				{
					pdp->N = atoi(pomocnicza);
					err++;
					BLAD = 0;
 
				}

				if((FLAGA == 1) && (licznik -1 < pdp->N))//wczytuje wektor kosztw funkcji celu
				{
					*(pdp->tab_C + licznik - 1) = atoi(pomocnicza);
					err++;
					BLAD = 0;
				}

				if((FLAGA == 2) && (licznik == 1)) //wczytuje liczb ogranicze
				{
					pdp->M = atoi(pomocnicza);
					BLAD = 0;
				}

				if((FLAGA == 3) && (licznik -1 < pdp->N))//wczytuje I rwnania ograniczajce
				{
					
					*(pdp->tab_A + licznik - 1) = atoi(pomocnicza);
					err++;
					BLAD = 0;
				}

				if((FLAGA > 3) && (FLAGA < pdp->M + 3) && (licznik - 1 < pdp->N)) //wczytuje kolejne ograniczenia
				{
					*(pdp->tab_A + (FLAGA -3)*pdp->N + licznik -1) = atoi(pomocnicza);
					err++;
					BLAD = 0;
				}

				if ((FLAGA == pdp->M + 3) && (licznik - 1 < pdp->M)) ////wczytuje wektor prawych stron ogranicze
				{
					*(pdp->tab_B + licznik - 1) = atoi(pomocnicza);
					err++;
					BLAD = 0;
				}
			}
			else
			{
				BLAD = 1;
				Err_Komunikat(RGB(255,0,0), hwnd, "Sprawdz czy poprawnie wpisae dane");
				SetFocus (GetDlgItem (hwnd, 1002)); 
				break;
			}
			ZeroMemory(&pomocnicza, sizeof(pomocnicza));
	   }
   }//tutaj koczy si ptla for

   //****************************************************
   //program idzie dalej jeli poprawnie wprowadzono dane 
   if((FLAGA == 0) && (licznik == 1) && (BLAD == 0))
   {
	   if (pdp->N <=0)
	   {
			wypisz(hwnd, "%s\r\n","Bld -> Liczba zmiennych powinna by wiksza od zera");
			Err_Komunikat(RGB(200,0,0), hwnd, "Podaj jeszcze raz");
	   }
	   else
	   {
			FLAGA = 1;
			wypisz(hwnd, "%s%d\r\n", "Liczba zmiennych: ",pdp->N); 
			wypisz(hwnd, "%s\r\n","");
			wypisz(hwnd, "%s\r\n","Podaj wektor kosztw funkcji celu:");
			SetDlgItemText(hwnd, 1002, NULL);
			SetFocus (GetDlgItem (hwnd, 1002));
			Err_Komunikat(RGB(0,200,0), hwnd, "Wczytano pomylnie");

			//rezerwuje pami dla tablicy
			pdp->tab_C = (int*)malloc(pdp->N * sizeof(int));
	   }
   }
   else if ((FLAGA == 0) && (licznik > 1))
   {
		wypisz(hwnd, "%s\r\n","Bd podaj jeszcze raz:");
		Err_Komunikat(RGB(255,0,0), hwnd, "Podae za duo danych!!!");
   }
   else if((FLAGA == 1) && (licznik == pdp->N) && (BLAD == 0))
   {
	   FLAGA = 2;   
	   wypisz(hwnd, "%s\r\n","Wprowadzono nastpujc funkcj celu:");

	   for(int zz = 0; zz < pdp->N; zz++)
	   {
		   if (zz != pdp->N -1)	
		   {
			   if(*(pdp->tab_C + zz + 1) >= 0)
				  wypisz(hwnd, "%d%s%d%s", *(pdp->tab_C + zz), "*x", (zz+1), " + "); //wypisuje dodatni
			   else
					wypisz(hwnd, "%d%s%d%s", *(pdp->tab_C + zz), "*x", (zz+1), " "); //wypisuje ujemn
		   }
		   else 
			   wypisz(hwnd, "%d%s%d%s\r\n", *(pdp->tab_C + zz), "*x", (zz+1), ""); 
	   }

	   SetDlgItemText(hwnd, 1002, NULL);
	   SetFocus (GetDlgItem (hwnd, 1002));
	   Err_Komunikat(RGB(0,200,0), hwnd, "Wczytano pomylnie"); 
	   wypisz(hwnd, "%s\r\n","");
	   wypisz(hwnd, "%s\r\n","Podaj liczb ogranicze:");   
   }

   else if ((FLAGA == 1) && (licznik != pdp->N))
   {
		wypisz(hwnd, "%s\r\n","Bd podaj jeszcze raz:");
		Err_Komunikat(RGB(255,0,0), hwnd, "Podaj tyle danych ile jest zmiennych!!!");
   }

   else if((FLAGA == 2) && (licznik == 1) && (BLAD == 0))
   {
	   if (pdp->M <=0)
	   {
			wypisz(hwnd, "%s\r\n","Bld -> Liczba ogranicze powinna by wiksza od zera");
			Err_Komunikat(RGB(255,0,0), hwnd, "Podaj jeszcze raz");
	   }
	   else
	   {
			FLAGA = 3;
			wypisz(hwnd, "%s%d\r\n","Liczba ogranicze: ",pdp->M);
			wypisz(hwnd, "%s\r\n","");
			wypisz(hwnd, "%s\r\n","Podaj wsp. 1 rwnania ograniczajcego:");
			SetDlgItemText(hwnd, 1002, NULL);
			SetFocus (GetDlgItem (hwnd, 1002));
			Err_Komunikat(RGB(0,200,0), hwnd, "Wczytano pomylnie");

			//rezerwuje pami dla tablicy
			pdp->tab_A = (int*)malloc(pdp->M * pdp->N * sizeof(int));
	   }
   }
   else if ((FLAGA == 2) && (licznik != 1))
   {
		wypisz(hwnd, "%s\r\n","Bd podaj jeszcze raz:");
		Err_Komunikat(RGB(255,0,0), hwnd, "Podaj tyle danych ile jest zmiennych");
   }

   else if((FLAGA >= 3) && (FLAGA < pdp->M + 2)&& (licznik ==  pdp->N) && (BLAD == 0)) //tutaj cae wprowadzanie rwna ograniczajcych
   {

	   for(int zz=0; zz<pdp->N; zz++)
	   {
		   wypisz(hwnd, "%s%d\r\n", "Wprowadzono: ",(*(pdp->tab_A + (FLAGA -3)*pdp->N + zz)));
	   }

	   wypisz(hwnd, "%s\r\n","");
	   wypisz(hwnd, "%s%d%s\r\n","Podaj wsp. ",(FLAGA - 1)," rwnania ograniczajcego:");
	   SetDlgItemText(hwnd, 1002, NULL);
	   SetFocus (GetDlgItem (hwnd, 1002));
	   Err_Komunikat(RGB(0,200,0), hwnd, "Wczytano pomylnie");
	   FLAGA ++;
   }
   else if((FLAGA >= 3) && (FLAGA < pdp->M + 2)&& (licznik !=  pdp->N))
   {
		wypisz(hwnd, "%s\r\n","Bd podaj jeszcze raz:");
		Err_Komunikat(RGB(255,0,0), hwnd, "Podaj tyle danych ile jest zmiennych!!!");
   }

   else if((FLAGA == pdp ->M + 2) && (licznik == pdp->N) && (BLAD == 0))
   {
		for(int zz=0; zz<pdp->N; zz++)
	   {
		   wypisz(hwnd, "%s%d\r\n", "Wprowadzono: ",(*(pdp->tab_A + (FLAGA -3)*pdp->N + zz))); 
	   }

	   wypisz(hwnd, "%s\r\n","");
	   wypisz(hwnd, "%s\r\n","Podaj wektor prawych stron ogranicze");
	   SetDlgItemText(hwnd, 1002, NULL);
	   SetFocus (GetDlgItem (hwnd, 1002));
	   Err_Komunikat(RGB(0,200,0), hwnd, "Wczytano pomylnie");

	   //rezerwuje pami dla tablicy
	   pdp->tab_B = (int*) malloc(pdp->M * sizeof(int));
	   FLAGA ++;
   }
   else if((FLAGA == pdp ->M + 2) && (licznik != pdp->N))
   {
		wypisz(hwnd, "%s\r\n","Bd podaj jeszcze raz:");
		Err_Komunikat(RGB(255,0,0), hwnd, "Sprawdz czy poprawnie wpisae dane");
   }

   else if((FLAGA == pdp ->M + 3) && (licznik == pdp->M) && (BLAD == 0))
   {
		for(int zz=0; zz < pdp->M; zz++)
	   {
		   wypisz(hwnd, "%s%d\r\n", "Wprowadzono: ",(*(pdp->tab_B + zz))); 
	   }

	   wypisz(hwnd, "%s\r\n","");
	   wypisz(hwnd, "%s\r\n","Wprowadzono nastpujce rwnania ograniczajce:");
	   SetDlgItemText(hwnd, 1002, NULL);
	   SetFocus (GetDlgItem (hwnd, 1002));
	   Err_Komunikat(RGB(0,200,0), hwnd, "Wczytano pomylnie");

	   FLAGA ++;
   }

   else if((FLAGA == pdp ->M + 3) && (licznik != pdp->M))
   {
		wypisz(hwnd, "%s\r\n","Bd podaj jeszcze raz:");
		Err_Komunikat(RGB(255,0,0), hwnd, "Podaj tyle danych ile jest ogranicze");
   }

   if((FLAGA == pdp->M + 4) && (pdp->M > 0))
   {
		//wypisuje rwnania ograniczajce ktre wczytano
		for(int xx = 0; xx < pdp->M; xx++)
			for(int zz = 0; zz < pdp->N; zz++)
			{
				if (zz != pdp->N -1)	
				{
					if(*(pdp->tab_A + (xx*pdp->N + zz)+1) >= 0)
						wypisz(hwnd, "%d%s%d%s", *(pdp->tab_A + (xx*pdp->N + zz)), "*x", (zz+1), " + "); 
					else
						wypisz(hwnd, "%d%s%d%s", *(pdp->tab_A + (xx*pdp->N + zz)), "*x", (zz+1), " "); //wypisuje ujemn
				}
				else 
				{
					wypisz(hwnd, "%d%s%d%s", *(pdp->tab_A + (xx*pdp->N + zz)), "*x", (zz+1), " <= "); 
					wypisz(hwnd, "%d\r\n", *(pdp->tab_B + xx)); 
				}
			}
		wypisz(hwnd, "%s\r\n","");
		wypisz(hwnd, "%s\r\n","Wszystkie dane wprowadzono pomylnie");
		wypisz(hwnd, "%s\r\n","Moesz teraz wygenerowa raport");
		//ustawiam przycisk LICZ na aktywny
		EnableWindow(GetDlgItem (hwnd, 4),TRUE); mLicz = 1;
		EnableWindow(GetDlgItem (hwnd, 6),TRUE); mZapisz = 1;
		Err_Komunikat(RGB(0,0,200), hwnd, "Gotowe");

		//rezerwuje pami dla wyniku
		pdp->tab_X = (int*) malloc(pdp->N * sizeof(int));
		FLAGA++;
   }
   else if((FLAGA == pdp->M + 5) && (pdp->M > 0))
   {
	   SetDlgItemText(hwnd, 1002, NULL);
	   Err_Komunikat(RGB(0,0,200), hwnd, "Zero - jedunkowy addytywny algorytm Balasa");
   }
}

void Raport(HWND hwnd, PARAMETRY *pdp)
{
	Err_Komunikat(RGB(0,0,200), hwnd, "RAPORT");
	//czyszcze okienko
	SetDlgItemText(hwnd, 1001, NULL);
	//wypisuje rne informacje
	wypisz(hwnd, "%s\r\n","RAPORT");
	wypisz(hwnd, "%s\r\n","");
	
	wypisz(hwnd, "%s\r\n","Funkcja celu:");

	//wypisuje funkcje ceku
	for(int zz = 0; zz < pdp->N; zz++)
	{
		if (zz != pdp->N -1)	
		{
			if(*(pdp->tab_C + zz + 1) >= 0)
				   wypisz(hwnd, "%d%s%d%s", *(pdp->tab_C + zz), "*x", (zz+1), " + ");//wypisuje dodatni 
			else
				   wypisz(hwnd, "%d%s%d%s", *(pdp->tab_C + zz), "*x", (zz+1), " "); //wypisuje ujemn
		}
	    else 
			wypisz(hwnd, "%d%s%d%s\r\n", *(pdp->tab_C + zz), "*x", (zz+1), ""); 
	}
	wypisz(hwnd, "%s\r\n","");

	//wypisuje ograniczenia
	wypisz(hwnd, "%s\r\n","Ograniczenia:");
	for(int xx = 0; xx < pdp->M; xx++)
		for(int zz = 0; zz < pdp->N; zz++)
		{
			if (zz != pdp->N -1)	
			{
				if(*(pdp->tab_A + (xx*pdp->N + zz)+1) >= 0)
					wypisz(hwnd, "%d%s%d%s", *(pdp->tab_A + (xx*pdp->N + zz)), "*x", (zz+1), " + "); //wypisuje dodatni
				else
					wypisz(hwnd, "%d%s%d%s", *(pdp->tab_A + (xx*pdp->N + zz)), "*x", (zz+1), " "); //wypisuje ujemn
			}
			else 
			{
				wypisz(hwnd, "%d%s%d%s", *(pdp->tab_A + (xx*pdp->N + zz)), "*x", (zz+1), " <= "); 
				wypisz(hwnd, "%d\r\n", *(pdp->tab_B + xx)); 
			}
		}
	wypisz(hwnd, "%s\r\n","");
	//wypisuje wyniki
	if(pdp->EXIST == TRUE)
		wypisz(hwnd, "%s\r\n","Czy znaleziono optymalne rozwiazanie?  TAK");
	else if(pdp->EXIST == FALSE)
		wypisz(hwnd, "%s\r\n","Czy znaleziono optymalne rozwiazanie?  NIE");
	wypisz(hwnd, "%s\r\n","");
	
	if (pdp->EXIST == TRUE)
	{
		wypisz(hwnd, "%s\r\n","Optymalny wektor zmiennych decyzyjnych:");
		for (int a = 0; a < pdp->N; a++)
		{
			wypisz(hwnd, "%s%d%s%d%s", "x", (a+1), " = ", pdp->tab_X[a], "   "); 
		}
		wypisz(hwnd, "%s\r\n","");
		wypisz(hwnd, "%s\r\n","");
		wypisz(hwnd, "%s%d\r\n", "Optymalna warto funkcji celu: ",pdp->FVAL); 
		wypisz(hwnd, "%s\r\n","");
		wypisz(hwnd, "%s\r\n","Sprawdzenie ogranicze");

		int wynik = 0;
		for(int xx = 0; xx < pdp->M; xx++)
			for(int zz = 0; zz < pdp->N; zz++)
			{
				wynik = wynik + ((pdp->tab_A[xx*pdp->N + zz]) * (pdp->tab_X[zz]));
				if(zz == (pdp->N -1))
				{
					wypisz(hwnd, "%d%s%d\r\n", wynik, " <= ", pdp->tab_B[xx]); 
					wynik = 0;
				}
			}
	}

	wypisz(hwnd, "%s\r\n","");
	wypisz(hwnd, "%s\r\n","");
	wypisz(hwnd, "%s\r\n","Zero jedynkowy addytywny algorytm Balasa");

	//data i godzina
	char tmpbuf1[128];
	char tmpbuf2[128];

	wypisz(hwnd, "%s\t\t\t%s\r\n", _strtime(tmpbuf1), _strdate(tmpbuf2));

	EnableWindow(GetDlgItem (hwnd, 5),FALSE); mZpliku = 0;
	//przycisk WYCZYSC aktywny
	EnableWindow(GetDlgItem (hwnd, 3),TRUE); mWyczysc = 1;
	EnableWindow(GetDlgItem (hwnd, 2),FALSE); mStart = 0;
	DRUKUJ = 1;
}